% Copyright (C) 2008-2010 - Consortium Scilab - Digiteo - Michael Baudin
%
% This file must be used under the terms of the 
% Creative Commons Attribution-ShareAlike 3.0 Unported License :
% http://creativecommons.org/licenses/by-sa/3.0/


%% Chapter 5
\chapter{Missing optimization features in Scilab}
Several optimization features are missing in Scilab. 
Two classes of missing features are to analyse~:
\begin{itemize}
\item features which are not available in Scilab, but which are available as toolboxes (see previous section),
\item features which are not available neither in Scilab, nor in toolboxes.
\end{itemize}

Here is a list of features which are not available in Scilab, but are available in 
toolboxes. These features would be to include in Scilab.
\begin{itemize}
\item integer parameter with linear objective solver and sparse matrices : currently available in LPSOLVE toolbox, based on the 
simplex method,
\item linear objective with sparse matrices : currently available in LIPSOL, based on interior points method,
\item nonlinear objective and non linear constraints : currently available in interface to IPOPT toolbox, based on interior point methods, 
\item nonlinear objective and non linear constraints : currently available in interface to CONMIN toolbox, based on method of feasible directions,
\end{itemize}
Notice that IPOPT is a commercial product and CONMIN is a domain-public library. Therefore 
the only open-source, free, nonlinear solver with non linear constraints tool available with 
Scilab is the interface to CONMIN.

Here is a list of features which are not available neither in Scilab, nor in toolboxes.
\begin{itemize}
\item quadratic objective solver with sparse objective matrix,
\item simplex programming method (*),
\item non-linear objective with nonlinear constraints (*),
\item non-linear objective with nonlinear constraints problems 
based on sparse linear algebra,
\item enabling/disabling of unknowns or constraints, 
\item customization of errors for constraints.
\end{itemize}

Functionalities marked with a (*) would be available in Scilab if the MODULOPT 
library embedded in Scilab was updated.

